DotDotDot = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0", "CandyBar-2.0")

local DotDotDot = DotDotDot

local VERSION = tonumber(("$Revision: 10001 $"):match("%d+"))
DotDotDot.revision = VERSION
DotDotDot.versionstring = "0.02 |cffff8888r%d|r"
DotDotDot.version = DotDotDot.versionstring:format(VERSION)
DotDotDot.date = ("$Date: 2007-06-01 16:55:00 -0400 (Fri, 1 Jun 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")

DotDotDot.group1 = {}
DotDotDot.group2 = {}
DotDotDot.group3 = {}
DotDotDot.group4 = {}
DotDotDot.group5 = {}

DotDotDot.delaytime = 0.5

local BS = AceLibrary("Babble-Spell-2.2")
local media = AceLibrary:HasInstance("SharedMedia-1.0") and AceLibrary("SharedMedia-1.0") or { Fetch = function() return "Interface\\Addons\\DotDotDot\\textures\\default" end, List = function() return {"BantoBar"} end, Register = function() end, }
local parser = ParserLib:GetInstance("1.1")

local mType = media.MediaType and media.MediaType.STATUSBAR or "statusbar"

function DotDotDot:OnInitialize()
	self:RegisterDB("DotDotDotDB")
	self:RegisterDefaults("profile", {
		growup = false,
		texture = "BantoBar",
		scale = 1.0
	})
	media:Register(mType, "BantoBar", "Interface\\Addons\\DotDotDot\\textures\\default")
	
	self.options = {
		type = "group",
		args = {
			anchor = {
				name = "Show Anchor",
				desc = "Show the Anchor for moving the Bars",
				type = "execute",
				func = "ShowAnchors",
			},
			growup = {
				name = "Grow Up",
				desc = "Toggle Grow Up of the Bars",
				type = "toggle",
				get = function()
					return self.db.profile.growup
				end,
				set = function(v)
					self.db.profile.growup = v
				end,
			},
			scale = {
				get = function()
					return self.db.profile.scale
				end,
				set = function(v)
					self.db.profile.scale = v
				end,
				min = 0.25, -- some like it small : but not too small!
				max = 2, -- some like it big
				step = 0.05, -- every 5%
				isPercent = true,
				name = "Bar scale",
				desc = "Set the scale of the bars",
				type = "range",
				func = "SetScale",
			},
			texture = {
				type = "text",
				name = "Texture",
				desc = "Set the texture for the bars.",
				validate = media:List(mType),
				get = function() return self.db.profile.texture end,
				set = function(tex) self.db.profile.texture = tex end,
			},
		}
	}
	
	self:RegisterChatCommand({ "/ddd", "/dotdotdot" }, self.options )
	
	-- spell = duration - this section is deprecated as of 2.1, maintained just in case 
	-- I happen to need it again b/c I am too lazy to type all this back out
--	self.track = {
--		[BS['Curse of the Elements']] = 120,
--		[BS['Curse of Weakness']] = 120,
--		[BS['Curse of Shadow']] = 120,
--		[BS['Curse of Recklessness']] = 120,
--		[BS['Vampiric Embrace']] = 60,
--		[BS['Vampiric Touch']] = 15,
--		[BS['Devouring Plague']] = 24,
--		[BS['Shadow Word: Pain']] = 24,
--		[BS['Shadowfiend']] = 15,
--		[BS['Curse of Agony']] = 24,
--		[BS['Curse of Tongues']] = 30,
--		[BS['Curse of Exhaustion']] = 12,
--		[BS['Siphon Life']] = 30,
--		[BS['Corruption']] = 18,
--		[BS['Curse of Doom']] = 60,
--		[BS['Unstable Affliction']] = 18,
--		[BS['Immolate']] = 15,
--	}

-- 5 min curses are disabled until CandyBar change goes in to provide time > length CandyBars
	self.shortcode = {
--		[BS['Curse of the Elements']] = 'CoE',
--		[BS['Curse of Weakness']] = 'CoW',
--		[BS['Curse of Shadow']] = 'CoS',
--		[BS['Curse of Recklessness']] = 'CoR',
		[BS['Vampiric Embrace']] = 'VE',
		[BS['Vampiric Touch']] = 'VT',
		[BS['Devouring Plague']] = 'DP',
		[BS['Shadow Word: Pain']] = 'SW:P',
		[BS['Shadowfiend']] = 'Fiend',
		[BS['Curse of Agony']] = 'CoA',
		[BS['Curse of Tongues']] = 'CoT',
		[BS['Curse of Exhaustion']] = 'CoEx',
		[BS['Siphon Life']] = 'Siphon',
		[BS['Corruption']] = 'Corr',
		[BS['Curse of Doom']] = 'CoD',
		[BS['Unstable Affliction']] = 'UA',
		[BS['Immolate']] = 'Immol',
	}

end

function DotDotDot:OnEnable()
	self:SetupFrames()
	self:RegisterEvent("PLAYER_TARGET_CHANGED", "TargetEvent")
	self:RegisterBucketEvent("UNIT_AURA", 0.2, "AuraEvent")
	parser:RegisterInfoType("DotDotDot", "death", DotDotDot.RemoveOnDeath)
end

function DotDotDot:RemoveOnDeath(info)
	local self = DotDotDot;
	for k,v in pairs(self.shortcode) do
		text = v.." - "..(info.victim)
		local id = ("DotDotDot%s"):format(text)
		self:UnregisterCandyBar(id)
	end
end

function DotDotDot:UpdateDebuffs(unit)
	self = DotDotDot
	if (UnitExists(unit)) then
		for num = 1, 40 do
			local name, _, texture, applications, _, duration, timeLeft
			name, _, texture, applications, _, duration, timeLeft = UnitDebuff(unit, num)
			if ((self.shortcode[name]) and (duration)) then
				self:ShowCandyBar(self.shortcode[name].." - "..(UnitName(unit) or ""), timeLeft, BS:GetSpellIcon(name), "green", "yellow", "orange", "red")
			end
		end			
	end
end

function DotDotDot:TargetEvent()
	if (UnitExists("target")) then
		self:UpdateDebuffs("target")
	end
end

function DotDotDot:AuraEvent(units)
	for unit in pairs(units) do
		if (UnitIsUnit("focus",unit) or UnitIsUnit("target",unit)) then
			self:UpdateDebuffs(unit)
		end
	end
end

function DotDotDot:ShowCandyBar(text, time, icon, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10)
	self = DotDotDot
	local id = ("DotDotDot%s"):format(text)
	local u = self.db.profile.growup
	local s = self.db.profile.scale
	
--	DEFAULT_CHAT_FRAME:AddMessage(id.." "..time)

	if (not(self:IsCandyBarRegistered(id))) then
		self:RegisterCandyBarGroup("DotDotDotGroup1")
		self:SetCandyBarGroupPoint("DotDotDotGroup1", u and "BOTTOM" or "TOP", self.frames.anchor, u and "TOP" or "BOTTOM", 0, 0)
		self:SetCandyBarGroupGrowth("DotDotDotGroup1", u)
		self:RegisterCandyBar(id, 60, text, icon, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10)
		self:RegisterCandyBarWithGroup(id, "DotDotDotGroup1")
		self:SetCandyBarTexture(id, media:Fetch(mType, self.db.profile.texture))
		self:SetCandyBarFade(id, 5)
		self:SetCandyBarScale(id, s)
		self:SetCandyBarTimeLeft(id, time)
		self:StartCandyBar(id, true)
	else
		self:SetCandyBarTimeLeft(id, time)
	end
end